<ng-content></ng-content>
<div class="product" [ngClass]="product | productType" [class.full-details]="fullDetails">
    <div class="main-info">
        <div class="product-icon">
            <mat-icon [svgIcon]="product | productType"></mat-icon>
        </div>

        <div class="name-info-wrapper">

            <ng-container *ngIf="!fullDetails; else NameFullDetails">
                <!-- Unit u -->

                <span class="product-name">{{ product | productName}}</span>
                <!-- Unit gr-->
                <span>- &#160;</span>
                <!-- Mass edit control -->
                <span *ngIf="!editMassMode; else editMassModeEnabled" id="unit-product" class="unit gr"
                    (click)="edit()">
                    {{ mass }}{{product.macros.massUnit}}
                </span>
                <!-- Edit mass mode enable -->
                <ng-template #editMassModeEnabled>
                    <input #editMassInput class="edit-mass-input" type="number" name="mass" autofocus
                        [(ngModel)]="pendingValue" (keydown.Enter)="processChanges()"
                        (keydown.Meta.Enter)="processChanges()" (keydown.Escape)="cancelEdit()"
                        [editMassMode]="editMassMode" (clickOutside)="editMassMode = false">
                </ng-template>

            </ng-container>

            <ng-template #NameFullDetails>

                <span class="product-name">{{ product | productName}}</span>
                <!-- Unit gr-->
                <div *ngIf="fullDetails" class="details">
                    <span class="unit gr">
                        {{ product.macros.calories }}kcal
                    </span>
                    &bull;
                    <span class="unit gr">
                        {{ product.macros.mass }}{{product.macros.massUnit}}
                    </span>

                </div>
            </ng-template>

        </div>

        <div class="options">
            <ng-container *ngIf="!fullDetails; else optionsFullDetails">
                <button mat-icon-button [matMenuTriggerFor]="menu">
                    <mat-icon>more_vert</mat-icon>
                </button>
                <mat-menu #menu="matMenu">
                    <button mat-menu-item (click)="delete()">
                        <mat-icon>delete</mat-icon>
                        <span>Delete</span>
                    </button>
                </mat-menu>
            </ng-container>

            <ng-template #optionsFullDetails>
                <button mat-icon-button (click)="toggle()">
                    <mat-icon>expand_more</mat-icon>
                </button>
            </ng-template>
        </div>

    </div>

    <div [@bodyExpansion]="state" class="expandable-content {{state}}">
        <ul>
            <li>Marca: <span> {{ product.brand }}</span></li>
            <li>Tipo: <span> {{ product.type }}</span></li>
        </ul>
    
    </div>
</div>